package com.base.store;

import java.io.Serializable;
import java.util.Set;

import org.neo4j.graphdb.Direction;
import org.springframework.data.neo4j.annotation.GraphId;
import org.springframework.data.neo4j.annotation.NodeEntity;
import org.springframework.data.neo4j.annotation.RelatedTo;



@NodeEntity
public class Account implements Serializable{
	
	private static final long serialVersionUID = 1L;
	/** Graph Fields **/	

	@RelatedTo(type="FOLLOWS", direction=Direction.OUTGOING, elementClass = Account.class) 
	private Set<Account> following;
	@RelatedTo(type="FOLLOWS", direction=Direction.INCOMING, elementClass = Account.class) 
	private Set<Account> followers;

	/** End of Graph Fields **/
	
	
	@GraphId
	private Long accountId;
	
	private String name;

	private String emailAddress;
		
	private int version;
	

	public void follow(Account follow){
		if(!this.equals(follow)){
			getFollowing().add(follow);
				
			}
		}
	
	public void unfollow(Account unfollow){
		for(Account following : getFollowing()){
			if(following.equals(unfollow)){
				getFollowing().remove(unfollow);
			}
		}
	}		

	public Long getAccountId() {
		return accountId;
	}
	public void setAccountId(Long accountId) {
		this.accountId = accountId;
	}
	public String getName() {
		return name;
	}
	public void setName(String name) {
		this.name = name;
	}
	public String getEmailAddress() {
		return emailAddress;
	}
	public void setEmailAddress(String emailAddress) {
		this.emailAddress = emailAddress;
	}
	
	public int getVersion() {
		return version;
	}

	public void setVersion(int version) {
		this.version = version;
	}

	public Set<Account> getFollowing() {
		return following;
	}

	public void setFollowing(Set<Account> following) {
		this.following = following;
	}

	public Set<Account> getFollowers() {
		return followers;
	}

	public void setFollowers(Set<Account> followers) {
		this.followers = followers;
	}

	@Override
	public String toString(){
		return "Account Id: "+accountId+", Email Address:"+emailAddress+", Name: "+name+", Version: "+version;
	}
	
}
