package com.base.store.config;

import static org.springframework.beans.factory.config.BeanDefinition.SCOPE_PROTOTYPE;

import org.springframework.context.annotation.AdviceMode;
import org.springframework.context.annotation.Bean;
import org.springframework.context.annotation.ComponentScan;
import org.springframework.context.annotation.Configuration;
import org.springframework.context.annotation.Scope;
import org.springframework.data.neo4j.config.EnableNeo4jRepositories;
import org.springframework.data.neo4j.cross_store.config.CrossStoreNeo4jConfiguration;
import org.springframework.data.neo4j.rest.SpringRestGraphDatabase;
import org.springframework.data.neo4j.support.mapping.Neo4jMappingContext;
import org.springframework.transaction.annotation.EnableTransactionManagement;

@Configuration
@EnableTransactionManagement(mode=AdviceMode.ASPECTJ)
@EnableNeo4jRepositories(value={"com.base.store.repository"})
@ComponentScan(basePackages = {"com.base.store.service"})
public class Neo4JConfig extends CrossStoreNeo4jConfiguration{
	@Bean(destroyMethod = "shutdown")
	@Scope(SCOPE_PROTOTYPE)
	public SpringRestGraphDatabase graphDatabaseService(){
		return new SpringRestGraphDatabase("http://localhost:7474/db/data");
	}


    @Bean
    public Neo4jMappingContext neo4jMappingContext() {
        return new Neo4jMappingContext();
    }

}
